{-# LANGUAGE PatternSynonyms, ScopedTypeVariables, ViewPatterns #-}


{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GdkPixbuf.Constants
    ( 
    pattern PIXBUF_VERSION                  ,
    pattern PIXBUF_MINOR                    ,
    pattern PIXBUF_MICRO                    ,
    pattern PIXBUF_MAJOR                    ,
    pattern PIXBUF_FEATURES_H               ,

    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


{- |
Contains the full version of the gdk-pixbuf header as a string.
This is the version being compiled against; contrast with
@/gdk_pixbuf_version/@.
-}
pattern PIXBUF_VERSION = "2.38.1" :: T.Text

{- |
Minor version of gdk-pixbuf library, that is the \"8\" in
\"0.8.2\" for example.
-}
pattern PIXBUF_MINOR = 38 :: Int32

{- |
Micro version of gdk-pixbuf library, that is the \"2\" in
\"0.8.2\" for example.
-}
pattern PIXBUF_MICRO = 1 :: Int32

{- |
Major version of gdk-pixbuf library, that is the \"0\" in
\"0.8.2\" for example.
-}
pattern PIXBUF_MAJOR = 2 :: Int32

{- |
/No description available in the introspection data./
-}
pattern PIXBUF_FEATURES_H = 1 :: Int32


